package org.linphone;

import org.linphone.core.LinphoneCore;

import android.os.Handler;
import android.text.Editable;
import android.text.TextWatcher;

public class RttTextWatcher implements TextWatcher {
	private CharSequence bc;
	private boolean enable;
	Handler h = new Handler();
	
	public RttTextWatcher() {
		enable = true;
		bc = null;
	}
	public void enable(boolean e) {
		enable = e;
	}
	
	public void afterTextChanged(Editable s) {}
	public void beforeTextChanged(CharSequence cs, int start, int count,
			int after) {
		if (!enable)
			return;
		if (count>0) {
			bc = cs.subSequence(start,start+count);
		} else {
			bc = null;
		}
	}
	
	public void onTextChanged(CharSequence cs, int start, int before,
			int count) {
		if (!enable) return;
		//LinphoneCore lc=LinphoneService.instance().getLinphoneCore();
		int ic=count;
		int remove;
		int i;
		
		if (bc != null) { 
			remove = bc.length();
		} else {
			remove = 0;
		}

		i=0;
		while (remove>0&&ic>0) {
			if (cs.charAt(start+i)!=bc.charAt(i)) {
				break;
			}
			i++;
			ic--;
			remove--;	
		}	
		
		i=count-ic;
		final CharSequence cc;
		final int rr=remove;
		
		
		if(i<count){
			cc = cs.subSequence(start+i, start+count);
		}else{
			cc = null;
		}
			
		h.post(new Runnable() {	
			@Override public void run() {
				//SEND rr BS
				LinphoneCore lc = LinphoneManager.getLc();
				for (int i=0;i<rr;i++)
					lc.textStreamPutchar32(0x08);
				//SEND CHARS IN cc
				if (cc!=null){
					for (int i=0;i<cc.length();i++)
						lc.textStreamPutchar32((int)cc.charAt(i));
				}
			}
		});
	}
}
